% ---------------------------------------------
% j668 data to Christian
% 2021 1130
% ---------------------------------------------
clc
clear
load('j668.mat');

set(0, 'DefaultTextInterpreter','latex');
set(0, 'DefaultLegendInterpreter','latex');


fig_num = 1; 

clf(figure(fig_num))
figure(fig_num)

for i_sub=[1 2 4]
    
    subplot(2, 2, i_sub)
    
    if i_sub==1 % plot band energy & e,h density
        subplot(2, 2, [1 3]);
        fill([zg zg], v_qw, [.8 .8 .8], 'facealpha', .5, ...
            'Linestyle','none');hold on 

%         ----plot V_QW at t2
         y1 = phi_ht_c(it(2),:);
         pp2 = plot( zg, y1, 'b', 'linewidth',2 ); hold on 
         
         y1 = phi_ht_v(it(2),:);
         pp3 = plot( zg, y1, 'b' , 'linewidth',2 ); hold on
            
%         ----plot rho---- 
        dell = [200 -50]; 
        for jt = 1:2 % loop e,h 
            i1 = ind(jt); % help var
    %         ---plot rho_e
            ymax = max(dne(i1,:));
            norm = 130./ymax;
            y2 = dne(i1,:).*norm + dell(1);
            if jt==1 % line
                p1{jt} = plot(zg, y2, 'r--'); 
            else % shaded area
                temp = [ones(nz,1).*dell(1)  y2'];
                p1{jt} = fill([zg zg], temp, [1 .5 .5 ], 'facealpha',.7 , 'Linestyle','none');hold on 
            
            end
    %         ---plot rho_h
            ymax = max( abs(dnh(i1,:)) );
            norm = 130./ymax;
            y2 = dnh(i1,:).*norm + dell(2);
            if jt==1 % line
                ph{jt}  = plot(zg, y2,'r--'); 
            else
                temp = [ones(nz,1).*dell(2)  y2'];
                ph{jt} = fill([zg zg], temp, [1 .5 .5 ], 'facealpha',.7 , 'Linestyle','none');hold on 
                
            end
            
            legt{jt} = sprintf('%s @ t= %.0f fs', '$\rho$', t{1}(i1));
        end
        leg = legend([pp2, p1{1}, p1{2}(1)], ...
            {'Actual potential', legt{1:2}} );legend('boxoff'); 
        set(leg,'location','north');
        
        
        xlabel('z [A]')
        ylabel('QW potential [meV]');
        xlim(zr);
        ylim([-150 400]);
        xticks([-50:50:50]);
        yticks([-del_v 0 del_g del_g+del_c]);
        
        
    elseif i_sub==2 % plot n_e w/ HT
        [X, Y] = meshgrid(t{1}(itr), zg );
        
        log_dn = log10(dn_help + 1e-4);
        
        contourf(X, Y, log_dn(itr,:)' ,'LineColor','none');  hold on
        colormap('jet');

        
        pz = plot(t{1}, ze, 'w','linewidth', 4);
        pzh = plot(t{1}, zh, 'w--','linewidth', 4);
        
%         ---QW border
        z1 = -70;
        z2 = 70;
        z0 = 0;
        pz2 = plot( tr, [z1 z1], 'w--', 'linewidth',2);hold on
        plot( tr, [z2 z2], 'w--', 'linewidth',2);hold on
        plot( tr, [z0 z0], 'w--', 'linewidth',2);hold on
        
%         ----mark t
        for jt=1:2
            i1 = ind(jt);
            plot([1 1].*t{1}(i1), [-100 100], 'w-', 'linewidth', 2);
        end
        
        pp = plot([1 1].*(-80), [-100 100],'c');
        
        leg = legend([pz, pzh, pz2], ...
            {'$z_e$','$z_h$','QW border'} );legend('boxoff'); 
        set(leg,'location','northeast');
        
        title('Electron density, w/ HT');
        
        
        
        xlabel('t [fs]')
        ylabel('z [A]');
        xlim(tr);
        ylim(zr);
        xticks([-500 0 500]);
        yticks([-50 0 50]);
        
    elseif i_sub==4 % plot THz
        
        pp0 = area(t{1}, E{1}./max(E{1}), 'Facecolor',[.85 .85 .85],'Linestyle','none');hold on 
        y1 = E_tot(:,1);
        norm = max(abs(y1));
        E_thz = -y1./norm; 
        
        pp1 = plot(t{1}, E_thz, 'r','linewidth',2);hold on
        
        yy = E_tot(:,2);
        norm = max(abs(yy));
        pp2 = plot(t{1}, -yy./norm, 'r--','linewidth',1);hold on
        
        pp = plot([1 1].*(-80), [-100 100],'c');
        
        
        leg = legend([pp0 pp2 pp1 pp], ...
            {'Pump','w/o HT','w/ HT', 'THz peak'} );legend('boxoff'); 
        set(leg,'location','southwest');
        
        xlabel('t [fs]')
        ylabel('THz');
        xlim(tr);
        ylim([-1.1 1.1]);
        xticks([-500 0 500]);
        yticks([-1:.5:1]);
        
    end
    
    set(gca,'ticklength', [0.02 0.02])
    set(gca,'fontsize',14);    
    set(gca,'linewidth',2)  
    
end

titname = append( datestr(now, 'yyyy-mm-dd '), 'Charging-induced THz emission');
sgtitle(titname)
set(gcf,'color','w');

